// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../../../../packages/inferno/inferno-shared
//   ../../../../packages/inferno/inferno-vnode-flags

declare module 'inferno' {
    /** TypeDoc Comment */
    import { NO_OP } from 'inferno-shared';
    import { createComponentVNode, createTextVNode, createVNode, directClone, getFlagsForElementVnode, InfernoChildren, InfernoInput, normalizeChildren, normalizeProps, options, Props, Refs, VNode } from 'inferno/core/implementation';
    import { isUnitlessNumber } from 'inferno/DOM/constants';
    import { linkEvent } from 'inferno/DOM/events/linkEvent';
    import { createPortal, createRenderer, render } from 'inferno/DOM/rendering';
    import { EMPTY_OBJ } from 'inferno/DOM/utils/common';
    import { Component } from 'inferno/core/component';
    const version: string | undefined;
    export { Component, EMPTY_OBJ, InfernoChildren, InfernoInput, NO_OP, Props, Refs, VNode, createComponentVNode, createPortal, createRenderer, createTextVNode, createVNode, directClone, getFlagsForElementVnode, isUnitlessNumber, linkEvent, normalizeChildren, normalizeProps, options, render, version };
}

declare module 'inferno/core/implementation' {
    /**
        * @module Inferno
        */ /** TypeDoc Comment */
    import { ChildFlags, VNodeFlags } from 'inferno-vnode-flags';
    export interface VNode {
            children: InfernoChildren;
            childFlags: ChildFlags;
            dom: Element | null;
            className: string | null | undefined;
            flags: VNodeFlags;
            key: any;
            parentVNode: VNode | null;
            props: Props | null;
            ref: Ref | Refs | null;
            type: any;
    }
    export type InfernoInput = VNode | null | string | number;
    export type Ref = (node?: Element | null) => any;
    export type InfernoChildren = string | number | boolean | undefined | VNode | Array<string | number | VNode> | null;
    export interface Props {
            children?: InfernoChildren;
            ref?: Ref | null;
            key?: any;
            className?: string;
            [k: string]: any;
    }
    export interface Refs {
            onComponentDidMount?: (domNode: Element) => void;
            onComponentWillMount?(): void;
            onComponentShouldUpdate?(lastProps: any, nextProps: any): boolean;
            onComponentWillUpdate?(lastProps: any, nextProps: any): void;
            onComponentDidUpdate?(lastProps: any, nextProps: any): void;
            onComponentWillUnmount?(domNode: Element): void;
    }
    export function createVNode(flags: VNodeFlags, type: any, className?: string | null, children?: InfernoChildren, childFlags?: ChildFlags, props?: Props | null, key?: any, ref?: Ref | Refs | null): VNode;
    export function createComponentVNode(flags: VNodeFlags, type: any, props?: Props | null, key?: any, ref?: Ref | Refs | null): VNode;
    export function createTextVNode(text: any, key?: any): VNode;
    export function normalizeProps(vNode: any): any;
    export function directClone(vNodeToClone: VNode): VNode;
    export function createVoidVNode(): VNode;
    export function _normalizeVNodes(nodes: any[], result: VNode[], index: number, currentKey: string): void;
    export function getFlagsForElementVnode(type: string): VNodeFlags;
    export function normalizeChildren(vNode: any, children: any): any;
    export const options: {
            afterMount: null | Function;
            afterRender: null | Function;
            afterUpdate: null | Function;
            beforeRender: null | Function;
            beforeUnmount: null | Function;
            createVNode: null | Function;
            findDOMNodeEnabled: boolean;
            roots: Map<any, any>;
    };
}

declare module 'inferno/DOM/constants' {
    /**
        * @module Inferno
        */ /** TypeDoc Comment */
    export const xlinkNS = "http://www.w3.org/1999/xlink";
    export const xmlNS = "http://www.w3.org/XML/1998/namespace";
    export const svgNS = "http://www.w3.org/2000/svg";
    export const strictProps: Set<string>;
    export const booleanProps: Set<string>;
    export const namespaces: Map<string, string>;
    export const isUnitlessNumber: Set<string>;
    export const skipProps: Set<string>;
    export const delegatedEvents: Set<string>;
}

declare module 'inferno/DOM/events/linkEvent' {
    /**
      * Links given data to event as first parameter
      * @param {*} data data to be linked, it will be available in function as first parameter
      * @param {Function} event Function to be called when event occurs
      * @returns {{data: *, event: Function}}
      */
    export function linkEvent(data: any, event: any): {
        data: any;
        event: any;
    } | null;
}

declare module 'inferno/DOM/rendering' {
    import { InfernoChildren, InfernoInput } from 'inferno/core/implementation';
    export function render(input: InfernoInput, parentDom: Element | SVGAElement | DocumentFragment | null | HTMLElement | Node, callback?: Function): InfernoChildren;
    export function createRenderer(parentDom?: any): (lastInput: any, nextInput: any) => void;
    export function createPortal(children: any, container: any): any;
}

declare module 'inferno/DOM/utils/common' {
    export const EMPTY_OBJ: {};
    export function appendChild(parentDom: any, dom: any): void;
    export function insertOrAppend(parentDom: any, newNode: any, nextNode: any): void;
    export function documentCreateElement(tag: any, isSVG: boolean): Element;
    export function replaceChild(parentDom: any, newDom: any, lastDom: any): void;
    export function removeChild(parentDom: Element, dom: Element): void;
    export function callAll(arrayFn: Function[]): void;
}

declare module 'inferno/core/component' {
    import { Props, VNode } from 'inferno/core/implementation';
    export class Component<P, S> {
        static defaultProps: {} | null;
        state: S | null;
        props: P & Props;
        context: any;
        $BR: boolean;
        $BS: boolean;
        $PSS: boolean;
        $PS: S | null;
        $LI: any;
        $V: VNode | null;
        $UN: boolean;
        _lifecycle: null;
        $CX: null;
        $UPD: boolean;
        $QU: Function[] | null;
        constructor(props?: P, context?: any);
        componentDidMount?(): void;
        componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: P, nextContext: any): void;
        shouldComponentUpdate?(nextProps: P, nextState: S, nextContext: any): boolean;
        componentWillUpdate?(nextProps: P, nextState: S, nextContext: any): void;
        componentDidUpdate?(prevProps: P, prevState: S, prevContext: any): void;
        componentWillUnmount?(): void;
        getChildContext?(): void;
        forceUpdate(callback?: Function): void;
        setState(newState: {
            [k in keyof S]?: S[k];
        } | Function, callback?: Function): void;
        render(nextProps?: P, nextState?: any, nextContext?: any): any;
    }
}

